summaryrefslogtreecommitdiff
path: root/tests/tail-2/tail-n0f
diff options
context:
space:
mode:
authorJim Meyering <jim@meyering.net>2003-08-16 13:22:23 +0000
committerJim Meyering <jim@meyering.net>2003-08-16 13:22:23 +0000
commit6c4fe5054ccb9aa27778dc5139c06c058bcdfd53 (patch)
treebe92389d561c955b7dfda7455ba1c238ebff75f2 /tests/tail-2/tail-n0f
parent4c34fab639b0291279cf6c3ef475c3c34556961a (diff)
downloadcoreutils-6c4fe5054ccb9aa27778dc5139c06c058bcdfd53.tar.xz
*** empty log message ***
Diffstat (limited to 'tests/tail-2/tail-n0f')
-rwxr-xr-xtests/tail-2/tail-n0f51
1 files changed, 51 insertions, 0 deletions
diff --git a/tests/tail-2/tail-n0f b/tests/tail-2/tail-n0f
new file mode 100755
index 000000000..d13db9927
--- /dev/null
+++ b/tests/tail-2/tail-n0f
@@ -0,0 +1,51 @@
+#!/bin/sh
+# Make sure that `tail -n0 -f' and `tail -c0 -f' sleep
+# rather than doing what amounted to a busy-wait.
+# This bug was fixed for 5.0.91
+# It skips the test if your system lacks a /proc/$pid/status
+# file, or if its contents don't look right.
+
+if test "$VERBOSE" = yes; then
+ set -x
+ tail --version
+fi
+
+sleep 2 &
+pid=$!
+sleep .1
+grep '^State:[ ]*[S]' /proc/$pid/status > /dev/null 2>&1 || \
+ {
+ echo "$0:/proc/$pid/status: missing or 'different': skipping this test" 1>&2
+ (exit 77); exit 77
+ }
+kill $pid
+
+pwd=`pwd`
+t0=`echo "$0"|sed 's,.*/,,'`.tmp; tmp=$t0/$$
+trap 'status=$?; cd $pwd; chmod -R u+rwx $t0; rm -rf $t0 && exit $status' 0
+trap '(exit $?); exit $?' 1 2 13 15
+
+framework_failure=0
+mkdir -p $tmp || framework_failure=1
+cd $tmp || framework_failure=1
+touch empty || framework_failure=1
+echo anything > nonempty || framework_failure=1
+
+if test $framework_failure = 1; then
+ echo "$0: failure in testing framework" 1>&2
+ (exit 1); exit 1
+fi
+
+fail=0
+
+for file in empty nonempty; do
+ for c_or_n in c n; do
+ tail --sleep=4 -${c_or_n} 0 -f $file &
+ pid=$!
+ sleep .1
+ grep '^State:[ ]*[S]' /proc/$pid/status > /dev/null || fail=1
+ kill $pid
+ done
+done
+
+(exit $fail); exit $fail